diff --git a/cmd/zpool/zpool_main.c b/cmd/zpool/zpool_main.c
index e2df9aadb21..587639b1220 100644
--- a/cmd/zpool/zpool_main.c
+++ b/cmd/zpool/zpool_main.c
@@ -501,6 +501,96 @@ add_prop_list_default(const char *propname, char *propval, nvlist_t **props,
 	return (add_prop_list(propname, propval, props, B_TRUE));
 }
 
+static boolean_t
+setup_prop_list(const char *propname, char *propval, nvlist_t **props,
+    int call)
+{
+	spa_feature_t i;
+	char *prop;
+
+	/* String WITHOUT the 'feature@' part */
+	char *res = strstr(propname, "@") + 1;
+
+	if ((strcmp(propval, "disable") == 0 ||
+	    strcmp(propval, "disabled") == 0)) {
+		/*
+		 * Because we've choosen to disable (a) feature(s) we first
+		 * need to make sure we enable ALL features...
+		 * I.e. default=enabled
+		 */
+		if (call == 0) {
+			for (i = 0; i < SPA_FEATURES; i++) {
+				/* String WITH the 'feature@' part */
+				prop = safe_malloc(
+				    strlen(spa_feature_table[i].fi_uname)
+				    + 9);
+
+				strcpy(prop, "feature@");
+				strcat(prop, spa_feature_table[i].fi_uname);
+				prop[strlen(prop)] = '\0';
+
+				if (!nvlist_exists(*props,
+				    spa_feature_table[i].fi_uname) ||
+				    !nvlist_exists(*props, prop)) {
+					if (add_prop_list(prop,
+					    ZFS_FEATURE_ENABLED, props,
+					    B_TRUE))
+						return (B_TRUE);
+				}
+			}
+		}
+
+
+		/*
+		 * ... then we disable all BUT the one(s) we choosed to
+		 * disable.
+		 */
+		for (i = 0; i < SPA_FEATURES; i++) {
+			/* String WITH the 'feature@' part */
+			prop = safe_malloc(
+			    strlen(spa_feature_table[i].fi_uname) + 9);
+
+			strcpy(prop, "feature@");
+			strcat(prop, spa_feature_table[i].fi_uname);
+			prop[strlen(prop)] = '\0';
+
+			if (strcmp(prop, propname) == 0)
+				(void) nvlist_remove_all(*props, prop);
+		}
+	} else if ((strcmp(propval, "enable") == 0 ||
+		    strcmp(propval, "enabled") == 0)) {
+		/*
+		 * Because we've choosen to enable (a) feature(s) we first
+		 * need to make sure we disable ALL features, then we enable
+		 * only the one(s) we've choosed to enable.
+		 *
+		 * I.e. default=disabled
+		 */
+		for (i = 0; i < SPA_FEATURES; i++) {
+			/* String WITH the 'feature@' part */
+			char *prop = safe_malloc(
+			    strlen(spa_feature_table[i].fi_uname) + 9);
+
+			strcpy(prop, "feature@");
+			strcat(prop, spa_feature_table[i].fi_uname);
+			prop[strlen(prop)] = '\0';
+
+			if (!nvlist_exists(*props,
+			    spa_feature_table[i].fi_uname) ||
+			    !nvlist_exists(*props, prop))
+				(void) nvlist_remove_all(*props, prop);
+
+			if (strcmp(spa_feature_table[i].fi_uname, res) == 0) {
+				if (add_prop_list(prop, ZFS_FEATURE_ENABLED,
+				    props, B_TRUE))
+					return (B_TRUE);
+			}
+		}
+	}
+
+	return (B_FALSE);
+}
+
 /*
  * zpool add [-fn] [-o property=value] <pool> <vdev> ...
  *
@@ -845,7 +935,7 @@ zpool_do_create(int argc, char **argv)
 	nvlist_t *nvroot = NULL;
 	char *poolname;
 	char *tname = NULL;
-	int ret = 1;
+	int ret = 1, call = 0;
 	char *altroot = NULL;
 	char *mountpoint = NULL;
 	nvlist_t *fsprops = NULL;
@@ -886,7 +976,15 @@ zpool_do_create(int argc, char **argv)
 			*propval = '\0';
 			propval++;
 
-			if (add_prop_list(optarg, propval, &props, B_TRUE))
+			if (zpool_prop_feature(optarg)) {
+				if (setup_prop_list(optarg, propval, &props,
+				    call))
+					goto errout;
+				else
+					enable_all_pool_feat = B_FALSE;
+				call++;
+			} else if (add_prop_list(optarg, propval, &props,
+			    B_TRUE))
 				goto errout;
 
 			/*
